<?php

setlocale(LC_ALL, "ru_RU");

require 'vendor/autoload.php';

use Symfony\Component\Process\Process;

$template = file_get_contents('template/43x25-2-label-case.svg');

$content = [
  ['Стяжка', 'межсекционная'],
  ['Шкант', ''],
  ['КОНФИРМАТ', ''],
  ['ПОДШИПНИК', ''],
  ['Заклепка', 'вытяжная'],
  ['Болт', 'М3'],
  ['Болт', 'М4'],
  ['Болт', 'М5'],
  ['Болт', 'М6'],
  ['Болт', 'М8'],
  ['Болт', 'М10'],
  ['Гайка', 'М3'],
  ['Гайка', 'М4'],
  ['Гайка', 'М5'],
  ['Гайка', 'М6'],
  ['Гайка', 'М8'],
  ['Гайка', 'М10'],
  ['Винт', 'М3'],
  ['Винт', 'М4'],
  ['Винт', 'М5'],
  ['Винт', 'М6'],
  ['Винт', 'М8'],
  ['Винт', 'М10'],
  ['Шайба', 'М3'],
  ['Шайба', 'М4'],
  ['Шайба', 'М5'],
  ['Шайба', 'М6'],
  ['Шайба', 'М8'],
  ['Шайба', 'М10'],
];

foreach($content as $item) {
    $tmpfile = './tmp/' . uniqid();

    $item[0] = mb_strtoupper($item[0]);

    $item = array_map(fn($v) => trim($v), $item);

    file_put_contents($tmpfile . '.svg', str_replace(['11111111', '22222222'], $item, $template));

    Process::fromShellCommandline('inkscape --export-filename=' . $tmpfile . '.pdf --export-overwrite --export-type=pdf --export-area-page --export-width=344 --export-height=200 --export-background=ffffff --export-background-opacity=255 ' . $tmpfile . '.svg')->run();

    Process::fromShellCommandline('convert -units PixelsPerCentimeter -density 203.2 ' . $tmpfile . '.pdf -interpolate integer -background white -monochrome ' . $tmpfile . '.png')->run();

    unlink($tmpfile . '.svg');
    unlink($tmpfile . '.pdf');
}
